VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsHtml"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit


' ---------------------------------------------------------------------------------------------
' \\ -- Descripcin:               Mdulo de clase para exportar un control
'                                  ListView en modo de vista reporte incluyendo
'                                  tambin los conos de cada item

' \\ -- Autor :                    Luciano Lodola -- http://www.recursosvisualbasic.com.ar/
' \\ -- Crditos:                  John Korejwa -- http://www.Planet-Source-Code.com/vb/scripts/ShowCode.asp?txtCodeId=50065&lngWId=1
' ---------------------------------------------------------------------------------------------

' Declaraciones, UDT, Constantes, Enumeraciones, Variables, Eventos
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Private Const OFN_HIDEREADONLY = &H4
Private Const OFN_FILEMUSTEXIST = &H1000
Private Const OFN_CREATEPROMPT = &H2000
Private Const OFN_OVERWRITEPROMPT = &H2
Private Const OFN_EXPLORER = &H80000

Private Const SW_SHOWNORMAL = 1
Private Const BIF_RETURNONLYFSDIRS = 1
Private Const MAX_PATH = 260

Private Type CHOOSECOLOR
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    rgbResult As Long
    lpCustColors As String
    flags As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type
Enum EOptionDialog
    [Normal] = 0
    [Completo] = 2
End Enum
Enum eOptionInsertHtml
    [Antes del Header] = 0
    [Despues del Header] = 1
    [Despues del subHeader] = 3
    [Antes del Pie] = 4
    [Despues del Pie] = 5
End Enum

Private Type TInsertHtml
    mOptionInsertHtml                    As eOptionInsertHtml
    mInsertHtml                          As String
End Type

Private arrInsertHtml()                  As TInsertHtml

Public Enum ealign
    [AlignLeft] = 0
    [AlignCenter] = 1
    [AlignRight] = 2
End Enum

Enum eAction
    [Add] = 0
    [Clear] = 1
End Enum

Private Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

Private Type BrowseInfo
    hwndOwner As Long
    pIDLRoot As Long
    pszDisplayName As Long
    lpszTitle As Long
    ulFlags As Long
    lpfnCallback As Long
    lParam As Long
    iImage As Long
End Type

Private Declare Function GetFileTitle Lib "comdlg32.dll" Alias "GetFileTitleA" (ByVal lpszFile As String, ByVal lpszTitle As String, ByVal cbBuf As Integer) As Integer
Private Declare Function CHOOSECOLOR Lib "comdlg32.dll" Alias "ChooseColorA" (pChoosecolor As CHOOSECOLOR) As Long
Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function GetTempFileName Lib "kernel32" Alias "GetTempFileNameA" (ByVal lpszPath As String, ByVal lpPrefixString As String, ByVal wUnique As Long, ByVal lpTempFileName As String) As Long
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal hMem As Long)
Private Declare Function lstrcat Lib "kernel32" Alias "lstrcatA" (ByVal lpString1 As String, ByVal lpString2 As String) As Long
Private Declare Function SHBrowseForFolder Lib "shell32" (lpBI As BrowseInfo) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long

Private Declare Function PathFindExtension Lib "shlwapi" Alias "PathFindExtensionA" (ByVal pPath As String) As Long
Private Declare Function lstrcpyA Lib "kernel32" (ByVal RetVal As String, ByVal Ptr As Long) As Long
Private Declare Function lstrlenA Lib "kernel32" (ByVal Ptr As Any) As Long


Private mPictureLogoPath                 As String
Private mPictureLogoAlign                As ealign

Private mTextHeader                      As String
Private mTextSubHeader                   As String

Private mTextFoother                     As String
Private mSizeBorderTable                 As Variant
Private mBorderColorTable                As String
Private mBackGroundColorTable            As String
Private mBackGroundColorHeader           As String
Private mAlignFontColumnHeader           As ealign
Private mAlignFontHeader                 As ealign
Private mFontSizeColumnHeaders           As Variant
Private mFontNameHeader                  As String
Private mFontNameSubHeader               As String
Private mFontColorColumnHeader           As String
Private mBackGroundColorCell             As String
Private mAlignFontCell                   As ealign
Private mFontColorCell                   As String
Private mFontSizeCell                    As Variant
Private mFontNameCell                    As String
Private mBackGroundColorPage             As String
Private mFontSizeHeader                  As Variant
Private mFontSizeSubHeader               As Variant
Private mFontColorHeader                 As String
Private mFontColorSubHeader              As String
Private mFontSizeFoother                 As Variant

Private mPictureBackGroundTable          As String
Private mBackGroundPicturePage           As String
Private mPictureCellItem                 As String

' Colores
'''''''''''''''''''''''''''
Dim color_borde_tabla                    As String
Dim color_fondo_tabla                    As String
Dim color_fondo_encabezado               As String
Dim color_fuente_encabezado              As String
Dim color_fuente_sub_titulo              As String
Dim color_fondo_celda                    As String
Dim color_fuente_celda                   As String
Dim color_fondo_pagina                   As String
Dim color_fuente_titulo                  As String

Dim Align_Encabezado_Col                 As String
Dim Align_Encabezado                     As String
Dim Align_Fuente_celda                   As String

Dim sBackGroundPicTable                  As String
Dim sBackGroundPicturePage               As String

Private mOutputPath                      As String


Private mImage                           As cImage
Private mJPG                             As cJpeg

Event Progress(ByVal ValueProgress As Integer)
Event EndExport()
Event InitExport()


' Inicio de la clase ( Valores por defecto)
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Sub Class_Initialize()
    Me.FontSizeCell = "2"
    Me.FontSizeColumnHeaders = "3"
    Me.FontSizeFoother = "2"
    Me.FontSizeHeader = "6"
    Me.FontSizeSubHeader = "3"
    ReDim arrInsertHtml(0)
End Sub


' Propiedades - texto
''''''''''''''''''''''''''''''''''
Property Get TextHeader() As String
    TextHeader = mTextHeader
End Property
Property Let TextHeader(Value As String)
    mTextHeader = Value
End Property

Property Get TextSubHeader() As String
    TextSubHeader = mTextSubHeader
End Property
Property Let TextSubHeader(Value As String)
    mTextSubHeader = Value
End Property
Property Get TextFoother() As String
    TextFoother = mTextFoother
End Property
Property Let TextFoother(Value As String)
    mTextFoother = Value
End Property

' Propiedades - Tamaos
''''''''''''''''''''''''''''''''''

Property Get SizeBorderTable() As Variant
    SizeBorderTable = mSizeBorderTable
End Property
Property Let SizeBorderTable(Value As Variant)
    If Not IsNumeric(Value) Then
       MsgBox "El valor ingresado no es un nmero", vbCritical
    Else
        mSizeBorderTable = CStr(Value)
    End If
End Property

Property Get FontSizeHeader() As Variant
    FontSizeHeader = mFontSizeHeader
End Property
Property Let FontSizeHeader(Value As Variant)
    If Not IsNumeric(Value) Then
       MsgBox "El valor ingresado no es un nmero", vbCritical
    Else
        mFontSizeHeader = CStr(Value)
    End If
End Property

Property Get FontSizeSubHeader() As Variant
    FontSizeSubHeader = mFontSizeSubHeader
End Property
Property Let FontSizeSubHeader(Value As Variant)
    If Not IsNumeric(Value) Then
       MsgBox "El valor ingresado no es un nmero", vbCritical
    Else
        mFontSizeSubHeader = CStr(Value)
    End If
End Property


Property Get FontSizeCell() As Variant
    FontSizeCell = mFontSizeCell
End Property

Property Let FontSizeCell(Value As Variant)
    If Not IsNumeric(Value) Then
       MsgBox "El valor ingresado no es un nmero", vbCritical
    Else
        mFontSizeCell = CStr(Value)
    End If
End Property

Property Get FontSizeColumnHeaders() As Variant
    FontSizeColumnHeaders = mFontSizeColumnHeaders
End Property
Property Let FontSizeColumnHeaders(Value As Variant)
    If Not IsNumeric(Value) Then
       MsgBox "El valor ingresado no es un nmero", vbCritical
    Else
        mFontSizeColumnHeaders = CStr(Value)
    End If
End Property

Property Get FontSizeFoother() As Variant
    FontSizeFoother = mFontSizeFoother
End Property
Property Let FontSizeFoother(Value As Variant)
    If Not IsNumeric(Value) Then
       MsgBox "El valor ingresado no es un nmero", vbCritical
    Else
        mFontSizeFoother = CStr(Value)
    End If
End Property


' Propiedades - Alineaciones
''''''''''''''''''''''''''''''''''

Property Get AlignFontHeader() As ealign
    AlignFontHeader = mAlignFontHeader
End Property

Property Let AlignFontHeader(Value As ealign)
    mAlignFontHeader = Value
End Property


Property Get AlignFontColumnHeader() As ealign
    AlignFontColumnHeader = mAlignFontColumnHeader
End Property

Property Let AlignFontColumnHeader(Value As ealign)
    mAlignFontColumnHeader = Value
End Property

Property Get AlignFontCell() As ealign
    AlignFontCell = mAlignFontCell
End Property

Property Let AlignFontCell(Value As ealign)
    mAlignFontCell = Value
End Property

Property Get PictureLogoAlign() As ealign
    PictureLogoAlign = mPictureLogoAlign
End Property

Property Let PictureLogoAlign(Value As ealign)
    mPictureLogoAlign = Value
End Property



' Propiedades -  Fuentes
''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Property Get FontNameHeader() As String
    FontNameHeader = mFontNameHeader
End Property
Property Let FontNameHeader(Value As String)
    mFontNameHeader = Value
End Property

Property Get FontNameSubHeader() As String
    FontNameSubHeader = mFontNameSubHeader
End Property
Property Let FontNameSubHeader(Value As String)
    mFontNameSubHeader = Value
End Property


Property Get FontNameCell() As String
    FontNameCell = mFontNameCell
End Property
Property Let FontNameCell(Value As String)
    mFontNameCell = Value
End Property



' Propiedades -  Colores
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Property Get BorderColorTable() As Variant
    BorderColorTable = mBorderColorTable
End Property

Property Let BorderColorTable(Value As Variant)
    mBorderColorTable = Value
End Property

Property Get BackGroundColorTable() As Variant
    BackGroundColorTable = mBackGroundColorTable
End Property

Property Let BackGroundColorTable(Value As Variant)
    mBackGroundColorTable = Value
End Property

Property Get BackGroundColorHeader() As Variant
    BackGroundColorHeader = mBackGroundColorHeader
End Property

Property Let BackGroundColorHeader(Value As Variant)
    mBackGroundColorHeader = Value
End Property

Property Get FontColorColumnHeader() As Variant
    FontColorColumnHeader = mFontColorColumnHeader
End Property

Property Let FontColorColumnHeader(Value As Variant)
    mFontColorColumnHeader = Value
End Property

Property Get BackGroundColorCell() As Variant
    BackGroundColorCell = mBackGroundColorCell
End Property

Property Let BackGroundColorCell(Value As Variant)
    mBackGroundColorCell = Value
End Property

Property Get BackGroundColorPage() As Variant
    BackGroundColorPage = mBackGroundColorPage
End Property

Property Let BackGroundColorPage(Value As Variant)
    mBackGroundColorPage = Value
End Property

Property Get FontColorHeader() As Variant
    FontColorHeader = mFontColorHeader
End Property

Property Let FontColorHeader(Value As Variant)
    mFontColorHeader = Value
End Property

Property Get FontColorSubHeader() As Variant
    FontColorSubHeader = mFontColorSubHeader
End Property

Property Let FontColorSubHeader(Value As Variant)
    mFontColorSubHeader = Value
End Property


Property Get FontColorCell() As Variant
    FontColorCell = mFontColorCell
End Property

Property Let FontColorCell(Value As Variant)
    mFontColorCell = Value
End Property


' Propiedades -  imagenes
''''''''''''''''''''''''''''


Property Get PictureLogoPath() As String
    PictureLogoPath = mPictureLogoPath
End Property

Property Let PictureLogoPath(Value As String)
    mPictureLogoPath = Value
End Property


Property Get PictureBackGroundTable() As String
    PictureBackGroundTable = mPictureBackGroundTable
End Property

Property Let PictureBackGroundTable(Value As String)
    mPictureBackGroundTable = Value
End Property

Property Get PictureCellItem() As String
    PictureCellItem = mPictureCellItem
End Property

Property Let PictureCellItem(Value As String)
    mPictureCellItem = Value
End Property

Property Get BackGroundPicturePage() As String
    BackGroundPicturePage = mBackGroundPicturePage
End Property

Property Let BackGroundPicturePage(Value As String)
    mBackGroundPicturePage = Value
End Property

' otros
'''''''''''''''''

Property Get OutputPath() As String
    OutputPath = mOutputPath
End Property
Property Let OutputPath(Value As String)
    mOutputPath = Value
End Property


'Funciones
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

' devuelve el directorio (path base) del archivo html ( propiedad mOutputPath )
Private Function GetPath(sValue As String) As String
    Dim sTemp As String

    sTemp = Left(sValue, InStrRev(sValue, "\"))
    If Right(sTemp, 1) = "\" Then
       sTemp = Left(sTemp, Len(sTemp) - 1)
    End If
    
    GetPath = sTemp & "\"

End Function


' Exportar a HTML ( Indicar el Objeto y el tipo )
Function ExportHtml(ListView As ListView, Optional ImageList As ImageList = Nothing, Optional intJPG_Quality = 80) As Boolean
    
    On Error GoTo error_function
    
    Dim sPathDir As String
    sPathDir = GetPath(mOutputPath)
    
    If sPathDir = "" Then
        MsgBox "No se ha indicado la ruta para generar el archivo html en la propiedad OutputPath", vbExclamation
        RaiseEvent EndExport
        Exit Function
    End If
    
    If Len(Dir(sPathDir, vbDirectory)) = 0 Then
       MkDir sPathDir
    End If
    
    RaiseEvent InitExport
    
    
    ' -- Mdulos para exportar los bmp a JPG
    Set mImage = New cImage
    Set mJPG = New cJpeg
    
    ' -- calidad jpg
    mJPG.Quality = intJPG_Quality
    
    ' Eliminar los archivos previos de la carpeta de imagenes
    Call DeleteFileTemp
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    
    
    ' REcuperar el color de los objetos y la alineacin
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    Call PrepColors
    Call PrepAlign
            
    ' Exportar
    '''''''''''''''''''''''''''''''''
     
    Dim sSourceHtml     As String
    Dim iRow            As Long
    Dim iCol            As Long
    Dim iImgWidth       As Integer
    Dim iImgheight      As Integer
    Dim nFreeFile       As Integer

    Screen.MousePointer = vbHourglass
    nFreeFile = FreeFile
    
    ' abrir el archivo
    '''''''''''''''''''''''''''''''''''
    Open mOutputPath For Output As nFreeFile
    
    
    Dim i As Integer
    Dim sDir As String
    
    sDir = GetPath(mOutputPath)
    
    If Len(Dir(sDir & "\imagenes", vbDirectory)) = 0 Then
       MkDir sDir & "\imagenes"
    Else
       Dim sFile As String
       sFile = Dir(sDir & "\imagenes" & "\*.*")
        While sFile <> ""
            Kill sDir & "\imagenes" & "\" & sFile
            sFile = Dir
        Wend
    End If
    
    If Not ImageList Is Nothing Then
    
        Dim frm         As Form
        Dim picTemp     As PictureBox
        
        Set frm = ImageList.Parent
        Set picTemp = frm.Controls.Add("vb.PictureBox", "picBmp")
        
        With picTemp
            .Width = ImageList.ImageWidth * Screen.TwipsPerPixelX
            .Height = ImageList.ImageHeight * Screen.TwipsPerPixelY
            .AutoRedraw = True
            .BackColor = ListView.BackColor
            .BorderStyle = 0
            .Visible = False
        End With
        
        Dim sJPGFile As String
        
        With ImageList
            iImgWidth = .ImageWidth
            iImgheight = .ImageHeight
            For i = 1 To .ListImages.Count
                If .ListImages(i).Picture.Type <> vbPicTypeIcon Then
                    mImage.CopyStdPicture .ListImages(i).Picture
                    mJPG.SampleHDC mImage.hDC, CLng(iImgWidth), CLng(iImgheight)
                
                    If .ListImages(i).Key = vbNullString Then
                        sJPGFile = sDir & "imagenes\" & i & ".jpg"
                    Else
                        sJPGFile = sDir & "imagenes\" & .ListImages(i).Key & ".jpg"
                    End If
                Else
                    picTemp.Cls
                    Call .ListImages(i).Draw(picTemp.hDC)
                    
                    mImage.CopyHDC picTemp.hDC, CLng(iImgWidth), CLng(iImgheight)
                    mJPG.SampleHDC mImage.hDC, CLng(iImgWidth), CLng(iImgheight)
                    
                    If .ListImages(i).Key = vbNullString Then
                        sJPGFile = sDir & "imagenes\" & i & ".jpg"
                    Else
                        sJPGFile = sDir & "imagenes\" & .ListImages(i).Key & ".jpg"
                    End If
                End If
                
                Call mJPG.SaveFile(sJPGFile)
                
                DoEvents
            Next
        End With
    End If
    
    ' CrearPictures
    '''''''''''''''''''''''''''''''''''
    Call CrearPictures(Me.OutputPath)
        
    ' cabecera de la pgina
    '''''''''''''''''''''''''''''''''''
    sSourceHtml = CrearCabecera(Me.OutputPath)
                   
    Call PrintHtml(sSourceHtml, nFreeFile)
                       
    sSourceHtml = CrearTabla()
    
    ' Exportar
    '''''''''''''''''''''''''''''''''''''''''''''''''''''''
    For iCol = 1 To ListView.ColumnHeaders.Count
        sSourceHtml = sSourceHtml & CrearTH(Trim(ListView.ColumnHeaders(iCol).Text), mFontSizeColumnHeaders, color_fuente_encabezado, mFontNameHeader, Align_Encabezado_Col)
    Next
    
    sSourceHtml = sSourceHtml & "</TR>" & vbCrLf
    Call PrintHtml(sSourceHtml, nFreeFile)
    
    For iRow = 1 To ListView.ListItems.Count
    
        sSourceHtml = sSourceHtml & "<TR bgcolor=" & color_fondo_celda & " > " & vbCrLf
        sSourceHtml = sSourceHtml & "<td " & "width=" & Chr(34) & CStr(iImgWidth) & Chr(34) & ">" & "<img src=imagenes/" & ListView.ListItems(iRow).SmallIcon & ".jpg" & " width=" & CStr(iImgWidth) & " height=" & CStr(iImgheight) & " align=absmiddle>" & "</td>"
        sSourceHtml = sSourceHtml & " <td><div align=" & Align_Fuente_celda & "><font color=" & color_fuente_celda & " size=" & mFontSizeCell & " face=" & mFontNameCell & ">" & "&nbsp;&nbsp;" & ListView.ListItems(iRow).Text & "</font></div></td>" & vbCrLf
        For iCol = 2 To ListView.ColumnHeaders.Count
            sSourceHtml = sSourceHtml & " <td><div align=" & Align_Fuente_celda & "><font color=" & color_fuente_celda & " size=" & mFontSizeCell & " face=" & mFontNameCell & ">" & ListView.ListItems(iRow).SubItems(iCol - 1) & "</font></div></td>" & vbCrLf
        Next
        
        sSourceHtml = sSourceHtml & "</TR>" & vbCrLf
        Call PrintHtml(sSourceHtml, nFreeFile)
        Call mRaiseEvent(ListView.ListItems.Count, iRow)
    Next
    
    sSourceHtml = sSourceHtml & "</TR>" & vbCrLf
    Call PrintHtml(sSourceHtml, nFreeFile)
    
    sSourceHtml = CrearPie(mFontSizeFoother, color_fuente_titulo, mTextFoother)

    ' imprimir el html final y cerrar el archivo
    Call PrintHtml(sSourceHtml, nFreeFile)
    Close #nFreeFile
    
    Screen.MousePointer = vbNormal
    
    frm.Controls.Remove "picBmp"
    Set picTemp = Nothing
    Set frm = Nothing
    Set mImage = Nothing
    Set mJPG = Nothing
    
    ExportHtml = True
    RaiseEvent EndExport
    

' errores
Exit Function

error_function:

    MsgBox Err.Description, vbCritical, "N de error: " & Err.Number
    Screen.MousePointer = vbDefault
    Close
    If Not mImage Is Nothing Then Set mImage = Nothing
    If Not mJPG Is Nothing Then Set mJPG = Nothing
    RaiseEvent EndExport
End Function

' funcin que usa la rutina "CrearPictures" para devolver el cdigo html para las imagenes
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Function getCodePicture(sPath As String, sNamefile As String, sDestino As String)

    Dim sTempPicture As String
        
    sNamefile = sNamefile & Replace(Timer, ",", "-")
    
    Dim sFinalPathImg As String
    Dim sOutputDirPath As String
    
    sOutputDirPath = GetPath(sDestino)
        
    ' path de imagenes
    If Len(Dir(sOutputDirPath & "imagenes", vbDirectory)) = 0 Then
       MkDir sOutputDirPath & "imagenes"
    End If
    
    If sPath = "" Then
        getCodePicture = ""
        Exit Function
    End If
    
    If Len(Dir(sPath)) = 0 Then
        MsgBox "No se encontr la ruta del archivo: " & sPath, vbCritical, "Error al cargar imagen"
        getCodePicture = ""
    Else
        On Error Resume Next
        sFinalPathImg = sOutputDirPath & "\imagenes" & "\" & sNamefile & "." & pvGetExtension(sPath)
        
        FileCopy sPath, sFinalPathImg
        getCodePicture = "imagenes/" & sNamefile & "." & pvGetExtension(sPath)
    End If
    
End Function


' Eleimina todos los archivos de la carpeta de imagenes
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Sub DeleteFileTemp()
    
    On Local Error Resume Next

    Dim sFile As String
    Dim sNameFolder As String
    Dim sLocalPath As String
    
    sLocalPath = GetPath(Me.OutputPath)
    sNameFolder = sLocalPath & GetNameFile(Me.OutputPath)
    
    If Len(Dir(sLocalPath, vbDirectory)) = 0 Then
       MkDir sLocalPath
    Else
       sFile = Dir(sNameFolder & "\*.*")

        While sFile <> ""
            Kill sNameFolder & "\" & sFile
            sFile = Dir
        Wend
    End If
    
End Sub


'Eventos - progreso
'''''''''''''''''''''''''''
Private Sub mRaiseEvent(VMax As Long, vValue As Long)
    If (((vValue * 100) / VMax)) <= 100 Then
        RaiseEvent Progress((vValue * 100) / VMax)
    End If
End Sub


'Crea el cdigo necesario para la imagen del fondo de la tabla, de la pgina y de la celda
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Sub CrearPictures(sDestino As String)
    
    ' imagen para el fondo de la tabla
    '''''''''''''''''''''''''''''''''''
    sBackGroundPicTable = ""
    sBackGroundPicturePage = ""
    
    sBackGroundPicTable = getCodePicture(mPictureBackGroundTable, "PictureBackGroundTable", sDestino)
    If sBackGroundPicTable <> "" Then
       sBackGroundPicTable = "background=" & sBackGroundPicTable
       color_fondo_tabla = ""
       color_fondo_celda = ""
    End If
    ' imagen para el fondo de la pgina
    '''''''''''''''''''''''''''''''''''
    sBackGroundPicturePage = getCodePicture(mBackGroundPicturePage, "BackGroundPicturePage", sDestino)
    If sBackGroundPicturePage <> "" Then
       sBackGroundPicturePage = " background=" & sBackGroundPicturePage
       color_fondo_pagina = ""
    End If
    
End Sub

' crea la tabla con los atributos
Private Function CrearTabla() As String
    
    Dim sTemp As String
    
    sTemp = "<TABLE width=100% " & sBackGroundPicTable & " BORDER=" & mSizeBorderTable & _
            " Bordercolor=" & color_borde_tabla & " bgcolor=" & color_fondo_tabla & ">" & vbCrLf
    
    CrearTabla = sTemp & "<TR bgcolor=" & color_fondo_encabezado & "> " & vbCrLf & " <TH width=16px>" & "</TH>" & vbCrLf
    
End Function

' crea el Pie de pgina y los insertHtml de pgina
Private Function CrearPie(ByVal mFontSizeFoother As String, ByVal color_fuente_titulo As String, ByVal mTextFoother As String) As String
    Dim sTemp As String

    sTemp = "</table>" & vbCrLf
    sTemp = sTemp & "<BR>" & chekInsertHtml([Antes del Pie])
    sTemp = sTemp & "<HR><font face=verdana size=" & mFontSizeFoother & " color=" & color_fuente_titulo & ">" & mTextFoother & "</font>" & "<P>"
    sTemp = sTemp & chekInsertHtml([Despues del Pie])
    CrearPie = sTemp & "</BODY><HEAD><META HTTP-EQUIV=PRAGMA CONTENT=NO-CACHE></HEAD></HTML>"
End Function

'Crear la cabecera y los Insert Html de cabecera
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Function CrearCabecera(ByVal sPathHtml As String) As String
    
    Dim sTemp As String
    
    sTemp = "<HTML><HEAD></HEAD>"
    sTemp = sTemp & "<BODY " & sBackGroundPicturePage & " BGCOLOR=" & color_fondo_pagina & ">" & vbCrLf
    
    If mPictureLogoPath <> "" Then
        
        Dim sAlign As String
        
        Select Case mPictureLogoAlign
            Case 0: sAlign = "left"
            Case 1: sAlign = "center"
            Case 2: sAlign = "right"
        End Select
        
        Dim sFinalPathImg As String
        Dim sOutputDirPath As String
        sOutputDirPath = GetPath(sPathHtml)
        
        Dim sLogo As String
        sLogo = "logo" & Replace(Timer, ",", "-")
        sFinalPathImg = sOutputDirPath & "\imagenes\" & sLogo & "." & pvGetExtension(mPictureLogoPath)
                        
        If mPictureLogoPath <> "" Then
           If Len(Dir(mPictureLogoPath)) <> 0 Then
              Call FileCopy(mPictureLogoPath, sFinalPathImg)
              sTemp = sTemp & "<p align=" & sAlign & "><img src=" & "imagenes/" & sLogo & "." & pvGetExtension(mPictureLogoPath) & "></p>"
           Else
              MsgBox "No se ha encontrado el archivo para el logo " & mPictureLogoPath, vbCritical
           End If
        End If
        
    End If
    
    sTemp = sTemp & chekInsertHtml([Antes del Header])
    sTemp = sTemp & "<p align=" & Align_Encabezado & "><font face=" & mFontNameHeader & " size=" & mFontSizeHeader & " color=" & color_fuente_titulo & ">" & mTextHeader & "</font></p><HR>"
    sTemp = sTemp & chekInsertHtml([Despues del Header])
    sTemp = sTemp & "<p><font face=" & mFontNameSubHeader & " size=" & mFontSizeSubHeader
    sTemp = sTemp & " color=" & color_fuente_sub_titulo & ">" & mTextSubHeader & "</font></p><HR>"
    sTemp = sTemp & chekInsertHtml([Despues del subHeader])
    CrearCabecera = sTemp
End Function

' Devuelve los cdigos Html insertados, si no hay retorna un vbnullstring
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Function chekInsertHtml( _
    OptionHtml As eOptionInsertHtml) As String
    
    Dim i As Integer
    
    For i = 1 To UBound(arrInsertHtml)
       If arrInsertHtml(i).mOptionInsertHtml = OptionHtml Then
          chekInsertHtml = arrInsertHtml(i).mInsertHtml
          Exit For
       End If
    Next
End Function

' Crear los headers
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Function CrearTH(ByVal sValue As String, ByVal sFonSizeHeader As String, ByVal sFontColor As String, ByVal SFontNameHeader As String, ByVal sAlignHEader As String) As String
    CrearTH = " <TH><div align=" & sAlignHEader & ">" & "<font size=" & sFonSizeHeader & " face=" & SFontNameHeader & " color=" & sFontColor & ">" & sValue & "</font></div></TH>" & vbCrLf
End Function

' devuelve el color ( si se pasa un long, se convierte, si se pasa un Html Hex se deja igual )
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Function getColor(sColorValue As String) As String
    
    If Trim(sColorValue) = "" Then
       getColor = ""
       Exit Function
    End If
    
    If InStr(sColorValue, "#") = 0 Then
       getColor = Me.GetHexadecimalFromRgb(sColorValue)
    Else
       getColor = sColorValue
    End If
End Function

' imprime el Html en el fichero abierto
'''''''''''''''''''''''''''''''''''''''''''''''''
Private Sub PrintHtml(ByRef Value As String, NFile As Integer)
    Print #NFile, Value
    Value = vbNullString
End Sub

' asigna en el array los html insertados, o los crea si no existe
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Sub InsertHtml(sValueHtml As String, OpTionInsert As eOptionInsertHtml)
    
    Dim i As Integer
    Dim lindex As Integer
    
    lindex = UBound(arrInsertHtml) + 1
    For i = 1 To UBound(arrInsertHtml)
        If arrInsertHtml(i).mOptionInsertHtml = OpTionInsert Then
           arrInsertHtml(i).mInsertHtml = sValueHtml
           Exit Sub
        End If
    Next
    
    ReDim Preserve arrInsertHtml(lindex)
    
    arrInsertHtml(lindex).mInsertHtml = sValueHtml
    arrInsertHtml(lindex).mOptionInsertHtml = OpTionInsert
        
End Sub


' devuelve solo el nombre del archivo html sin la extensin. ese nombre se usa pra crear la carpeta de imagenes
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Function GetNameFile(ByVal sPath As String) As String
  
    Dim sTemp As String
    Dim sNamefile As String
    Dim Buffer As String
    Buffer = String(255, 0)
    GetFileTitle sPath, Buffer, Len(Buffer)
    sTemp = Left$(Buffer, InStr(1, Buffer, Chr$(0)) - 1)
    
    Dim i As Integer
           
    For i = 1 To Len(sTemp)
        If Mid(sTemp, i, 1) <> "." Then
           sNamefile = sNamefile & Mid(sTemp, i, 1)
        Else
           Exit For
        End If
    Next
               
    GetNameFile = sNamefile
               
End Function

' rertorna un string con el cdigo Hex Html a partir de un long
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function GetHexadecimalFromRgb(ByVal Color As Long) As String

    Dim Azul As Byte, Verde As Byte, Rojo As Byte
    Dim sRojo As String, sVerde As String, sAzul As String

    Azul = (Color And 16711680) / 65536
    Verde = (Color And 65280) / 256
    Rojo = Color And 255

    If Len(Hex$(Azul)) = 1 Then
        sAzul = "0" & Hex$(Azul)
    Else
        sAzul = Hex$(Azul)
    End If

    If Len(Hex$(Verde)) = 1 Then
        sVerde = "0" & Hex$(Verde)
    Else
        sVerde = Hex$(Verde)
    End If

    If Len(Hex$(Rojo)) = 1 Then
        sRojo = "0" & Hex$(Rojo)
    Else
        sRojo = Hex$(Rojo)
    End If
    
    GetHexadecimalFromRgb = "#" & sRojo & sVerde & sAzul
End Function

' abre un fciehro con el programa asociado
''''''''''''''''''''''''''''''''''''''''''''''''''
Function OpenFile(SpathFile As String) As Boolean
    OpenFile = ShellExecute(0, vbNullString, SpathFile, vbNullString, vbNullString, SW_SHOWNORMAL)
End Function

' dilogo buscar carpeta
''''''''''''''''''''''''''''''''''''''''''''''''''
Function BrowseForFolder(lHwndOwner As Long, Optional sTitle As String = "Seleccionar directorio") As String

    Dim Nulo As Integer
    Dim Id_List As Long
    Dim El_Path As String
    Dim t_Explorar_dir As BrowseInfo
  
    With t_Explorar_dir
        .hwndOwner = lHwndOwner
        .lpszTitle = lstrcat(sTitle, "")
        .ulFlags = BIF_RETURNONLYFSDIRS + 64
    End With
  
    Id_List = SHBrowseForFolder(t_Explorar_dir)
    If Id_List Then
        El_Path = String$(MAX_PATH, 0)
        Call SHGetPathFromIDList(Id_List, El_Path)
        Call CoTaskMemFree(Id_List)
        
        Nulo = InStr(El_Path, vbNullChar)
  
        If Nulo Then
            El_Path = Left$(El_Path, Nulo - 1)
        End If
    End If
       
    BrowseForFolder = El_Path
End Function


' Abre el dilogo de windows para seleccionar color
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function ShowCommonDialogoColor(Optional OptionDialog As EOptionDialog = Normal) As Long

    Dim CustomColors() As Byte
    Dim cc As CHOOSECOLOR
    Dim Custcolor(16) As Long
    Dim lReturn As Long
  
    With cc
        .lStructSize = Len(cc)
        .hwndOwner = 0
        .hInstance = App.hInstance
        .lpCustColors = StrConv(CustomColors, vbUnicode)
    
        If OptionDialog = Completo Then
            .flags = 2
        Else
            .flags = 0
        End If
    End With
    If CHOOSECOLOR(cc) <> 0 Then
        ShowCommonDialogoColor = cc.rgbResult
        CustomColors = StrConv(cc.lpCustColors, vbFromUnicode)
    Else
        ShowCommonDialogoColor = -1
    End If
End Function
  
' Abre el dilogo de windows para seleccionar un archivo
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function ShowOpenFileDialog( _
    Optional sfilter As String, _
    Optional sTitle As String = "seleccionar archivo", _
    Optional sInitialDir As String = "") As String

Dim OFName As OPENFILENAME
Static sPath As String

    With OFName
        .lStructSize = Len(OFName)

        .hwndOwner = 0
        .hInstance = App.hInstance
        
        If Trim(sfilter) = vbNullString Then
           .lpstrFilter = "Todos los archivos (*.*)" + Chr$(0) + "*.*" + Chr$(0)
        Else
           .lpstrFilter = sfilter
        End If
         
        .lpstrFile = Space$(254)
        .nMaxFile = 255
        .lpstrFileTitle = Space$(254)
        .nMaxFileTitle = 255
        .lpstrInitialDir = sInitialDir
        
        .lpstrTitle = sTitle
        .flags = 0
    End With
    
    If GetOpenFileName(OFName) Then
        ShowOpenFileDialog = Trim$(Replace(OFName.lpstrFile, Chr(0), vbNullString))
    Else
        ShowOpenFileDialog = vbNullString
    End If
End Function

' Abre el dilogo de windows para guardar archivo
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function ShowSaveFileDialog( _
    sExtensiones As String, _
    Optional sTitle As String = "Guardar archivo", _
    Optional FilterIndex As Long = 0) As String
    
    On Local Error Resume Next

    Dim ofn As OPENFILENAME
    Dim a As Long
    Dim FileName As String
    
    ofn.lStructSize = Len(ofn)
    ofn.hwndOwner = 0
    ofn.hInstance = App.hInstance
    
    If VBA.Right$(sExtensiones, 1) <> "|" Then sExtensiones = sExtensiones + "|"
    
    For a = 1 To Len(sExtensiones)
        If Mid(sExtensiones, a, 1) = "|" Then Mid(sExtensiones, a, 1) = Chr(0)
    Next
    
    ofn.lpstrFilter = sExtensiones
    ofn.lpstrFile = Space(254)
    ofn.nMaxFile = 255
    ofn.lpstrFileTitle = Space(254)
    ofn.nMaxFileTitle = 255
    ofn.lpstrInitialDir = ""
    If Not FileName = vbNullString Then ofn.lpstrFile = FileName & Space(254 - Len(FileName))
    ofn.nFilterIndex = FilterIndex
    ofn.lpstrTitle = sTitle
    ofn.flags = OFN_HIDEREADONLY Or OFN_OVERWRITEPROMPT Or OFN_CREATEPROMPT Or OFN_EXPLORER
    
    a = GetSaveFileName(ofn)

    If a Then
       ShowSaveFileDialog = Trim$(ofn.lpstrFile)
       If VBA.Right$(Trim$(ShowSaveFileDialog), 1) = Chr(0) Then ShowSaveFileDialog = VBA.Left$(Trim$(ofn.lpstrFile), Len(Trim$(ofn.lpstrFile)) - 1) & GetExtFilter(ofn.lpstrFilter, ofn.nFilterIndex)
    Else
       ShowSaveFileDialog = vbNullString
    End If
End Function

' ----------------------------------------------------------------------
' -- Funcin de ajuste para usar con PathFindExtension
' ----------------------------------------------------------------------
Private Function pvGetExtension(ByVal sPath As String) As String
  Dim sTemp As String
  'Given a path and filename, return only the filename extension.
  sTemp = pvGetStrFromPtrA(PathFindExtension(sPath))
     
  If Len(sTemp) Then pvGetExtension = Replace(sTemp, ".", vbNullString)
End Function
  
' ----------------------------------------------------------------------------------
' \\ -- Devuelve un string desde un puntero
' ----------------------------------------------------------------------------------
Private Function pvGetStrFromPtrA(ByVal lpszA As Long) As String
  'Given a pointer to a string, return the string
   pvGetStrFromPtrA = String$(lstrlenA(ByVal lpszA), 0)
   Call lstrcpyA(ByVal pvGetStrFromPtrA, ByVal lpszA)
End Function
  

'Extrae la extension seleccionada del filtro:
Private Function GetExtFilter(sfilter As String, pos As Long) As String
    Dim Ext() As String
    
    Ext = Split(sfilter, vbNullChar)
    
    If pos = 1 And Ext(pos) <> "*.*" Then
        GetExtFilter = "." & Replace(Ext(pos), "*.", "")
        Exit Function
    End If
    If pos = 1 And Ext(pos) = "*.*" Then
        GetExtFilter = vbNullString
        Exit Function
    End If
    If InStr(Ext(pos + 1), "*.*") Then
       GetExtFilter = vbNullString
    Else
       GetExtFilter = "." & Replace(Ext(pos + 1), "*.", "")
    End If
End Function


' recupera los colores
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Sub PrepColors()
    color_borde_tabla = getColor(mBorderColorTable)
    color_fondo_tabla = getColor(mBackGroundColorTable)
    color_fondo_encabezado = getColor(mBackGroundColorHeader)
    color_fuente_encabezado = getColor(mFontColorColumnHeader)
    color_fondo_celda = getColor(mBackGroundColorCell)
    color_fuente_celda = getColor(mFontColorCell)
    color_fondo_pagina = getColor(mBackGroundColorPage)
    color_fuente_titulo = getColor(mFontColorHeader)
    color_fuente_sub_titulo = getColor(mFontColorSubHeader)
End Sub


' Alineaciones
'''''''''''''''''''''
Private Sub PrepAlign()

    Select Case mAlignFontColumnHeader
        Case 0: Align_Encabezado_Col = "Left"
        Case 1: Align_Encabezado_Col = "Center"
        Case 2: Align_Encabezado_Col = "Right"
        
    End Select
    
    Select Case mAlignFontCell
        Case 0: Align_Fuente_celda = "Left"
        Case 1: Align_Fuente_celda = "Center"
        Case 2: Align_Fuente_celda = "Right"
    End Select
    
    Select Case mAlignFontHeader
        Case 0: Align_Encabezado = "Left"
        Case 1: Align_Encabezado = "Center"
        Case 2: Align_Encabezado = "Right"
    End Select
    
End Sub

' Devuelve un nombre de archivo para crear el temporal para la vista previa
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Function getTempFileHtml() As String
    Dim sTemp As String
    Dim ret As Long
    
    sTemp = String(260, 0)
    ret = GetTempFileName(Environ("temp"), "TTT", 0, sTemp)
    getTempFileHtml = Left$(sTemp, InStr(1, sTemp, Chr$(0)) - 1)
End Function

Private Sub Class_Terminate()
    Erase arrInsertHtml
End Sub
